import React from 'react'
import { withStyles } from '@material-ui/core/styles'
import IconButton, { IconButtonProps } from '@material-ui/core/IconButton'
import StyledIconProps from 'components/CommonKit/Icon/StyledIcon'

const IconButtonBase = withStyles({
  root: {
    outline: 'none !important',
  },
})(IconButton)

interface StyledIconButtonProps extends IconButtonProps {
  icon: string
  size?: number
}

const StyledIconButton: React.ComponentType<StyledIconButtonProps> = ({
  icon,
  size = 16,
  ...props
}: StyledIconButtonProps) => {
  return (
    <IconButtonBase {...props}>
      <StyledIconProps icon={icon} size={size} />
    </IconButtonBase>
  )
}

export default StyledIconButton
