import React from 'react'
import { FluidType } from 'enum/fluid.enum'
import { withStyles } from '@material-ui/core/styles'
import MuiCircularProgress, {
  CircularProgressProps,
} from '@material-ui/core/CircularProgress'

const SpinnerBase = withStyles({
  root: {
    color: 'var(--blue)',
  },
})(MuiCircularProgress)

type StyledSpinnerProps = CircularProgressProps

const StyledSpinner: React.ComponentType<StyledSpinnerProps> = ({
  ...props
}: StyledSpinnerProps) => {
  return <SpinnerBase {...props} />
}

export default StyledSpinner
